org.apache.lucene.search.spans

## Class SpanScorer

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.DocsEnum
    - - org.apache.lucene.search.Scorer
      - - org.apache.lucene.search.spans.SpanScorer

- Direct Known Subclasses:
    PayloadNearQuery.PayloadNearSpanScorer, PayloadTermQuery.PayloadTermWeight.PayloadTermSpanScorer

      public class SpanScorer
      extends Scorer

  Public for extension only.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.search.Scorer

      `Scorer.ChildScorer`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `doc`
    `protected Similarity.SloppySimScorer` | `docScorer`
    `protected float` | `freq`
    `protected boolean` | `more`
    `protected int` | `numMatches`
    `protected Spans` | `spans`

    - ### Fields inherited from class org.apache.lucene.search.Scorer

      `weight`

    - ### Fields inherited from class org.apache.lucene.index.DocsEnum

      `FLAG_FREQS, FLAG_NONE`

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SpanScorer(Spans spans, Weight weight, Similarity.SloppySimScorer docScorer)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `int` | `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `int` | `freq()` Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`.
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `float` | `score()` Returns the score of the current document matching the query.
    `protected boolean` | `setFreqCurrentDoc()`
    `float` | `sloppyFreq()` Returns the intermediate "sloppy freq" adjusted for edit distance

    - ### Methods inherited from class org.apache.lucene.search.Scorer

      `getChildren, getWeight, score, score`

    - ### Methods inherited from class org.apache.lucene.index.DocsEnum

      `attributes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### spans

          protected Spans spans

    - #### more

          protected boolean more

    - #### doc

          protected int doc

    - #### freq

          protected float freq

    - #### numMatches

          protected int numMatches

    - #### docScorer

          protected final Similarity.SloppySimScorer docScorer

  - ### Constructor Detail

    - #### SpanScorer

          protected SpanScorer(Spans spans,
                    Weight weight,
                    Similarity.SloppySimScorer docScorer)
                        throws IOException

      Throws:
        `IOException`

  - ### Method Detail

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### advance

          public int advance(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### setFreqCurrentDoc

          protected boolean setFreqCurrentDoc()
                                       throws IOException

      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### score

          public float score()
                      throws IOException

      Description copied from class: `Scorer`
      Returns the score of the current document matching the query. Initially invalid, until `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` is called the first time, or when called from within `Collector.collect(int)`.
      Specified by:
        `score` in class `Scorer`
      Throws:
        `IOException`

    - #### freq

          public int freq()
                   throws IOException

      Description copied from class: `DocsEnum`
      Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`. Do not call this before `DocIdSetIterator.nextDoc()` is first called, nor after `DocIdSetIterator.nextDoc()` returns `DocIdSetIterator.NO_MORE_DOCS`.

      NOTE: if the `DocsEnum` was obtain with `DocsEnum.FLAG_NONE`, the result of this method is undefined.

      Specified by:
        `freq` in class `DocsEnum`
      Throws:
        `IOException`

    - #### sloppyFreq

          public float sloppyFreq()
                           throws IOException

      Returns the intermediate "sloppy freq" adjusted for edit distance
      Throws:
        `IOException`
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.